/* GCC */

#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>

#define MAX 2000

using namespace std;

struct dot{
    int x;
    int y;
};

struct trigret{
    long int surf;
    bool is_dot5;
};

int n;
dot dots[MAX + 2];
long int res = 0;
bool is_dot5_res = false;

const trigret operator-(trigret t1, trigret t2){
    t1.surf -= t2.surf;
    if(!t1.is_dot5 && t2.is_dot5){
        t1.surf--;
        t1.is_dot5 = true;
    }
    if(t1.is_dot5 && t2.is_dot5){
        t1.is_dot5 = false;
    }
    return t1;
}
const trigret operator+(trigret t1, trigret t2){
    t1.surf += t2.surf;
    if(t1.is_dot5 && t2.is_dot5){
        t1.surf++;
        t1.is_dot5 = false;
    }
    if(!t1.is_dot5 && t2.is_dot5){
        t1.is_dot5 = true;
    }
    return t1;
}

trigret triang(int a, int b, int c){
    long int surf = 0;
    bool is_dot5 = false;
    int minx = min(min(dots[a].x, dots[b].x), dots[c].x),
    miny = min(min(dots[a].y, dots[b].y), dots[c].y),
    maxx = max(max(dots[a].x, dots[b].x), dots[c].x),
    maxy = max(max(dots[a].y, dots[b].y), dots[c].y);
    int x = abs(maxx - minx);
    int y = abs(maxy - miny);
    surf = x * y;
    int ab = abs(dots[a].x - dots[b].x) * abs(dots[a].y - dots[b].y),
    bc = abs(dots[b].x - dots[c].x) * abs(dots[b].y - dots[c].y),
    ca = abs(dots[c].x - dots[a].x) * abs(dots[c].y - dots[a].y);
    if(ab % 2 == 1){
        if(!is_dot5)
            surf--;
        is_dot5 = !is_dot5;
    }
    if(bc % 2 == 1){
        if(!is_dot5)
            surf--;
        is_dot5 = !is_dot5;
    }
    if(ca % 2 == 1){
        if(!is_dot5)
            surf--;
        is_dot5 = !is_dot5;
    }
    surf -= ((ab / 2) + (bc / 2) + (ca / 2));
    bool isamid = dots[a].x == minx || dots[a].x == maxx || dots[a].y == miny || dots[a].y == maxy,
         isbmid = dots[b].x == minx || dots[b].x == maxx || dots[b].y == miny || dots[b].y == maxy,
         iscmid = dots[c].x == minx || dots[c].x == maxx || dots[c].y == miny || dots[c].y == maxy;
    if(!(isamid && isbmid && iscmid)){
        if(!isamid){
            if((dots[b].x == minx && dots[b].y == maxy) || (dots[c].x == minx && dots[c].y == maxy)){
                dots[n] = dot{minx, miny};
                dots[n + 1] = dot{maxx, maxy};
                trigret var1 = triang(b, a, n);
                trigret var2 = triang(a, c, n);
                trigret var3 = triang(b, a, n + 1);
                trigret var4 = triang(a, c, n + 1);
                trigret res1 = var1 + var2;
                trigret res2 = var3 + var4;
                trigret returned = {surf, is_dot5};
                if(res2.surf < res1.surf){
                    surf = (returned - res2).surf;
                    is_dot5 = (returned - res2).is_dot5;
                }else if(res1.surf > res2.surf){
                    surf = (returned - res1).surf;
                    is_dot5 = (returned - res1).is_dot5;
                }else if(!res1.is_dot5){
                    surf = (returned - res1).surf;
                    is_dot5 = (returned - res1).is_dot5;
                }else{
                    surf = (returned - res2).surf;
                    is_dot5 = (returned - res2).is_dot5;
                }
            }else{
                dots[n] = dot{minx, maxy};
                dots[n + 1] = dot{maxx, miny};
                trigret var1 = triang(b, a, n);
                trigret var2 = triang(a, c, n);
                trigret var3 = triang(b, a, n + 1);
                trigret var4 = triang(a, c, n + 1);
                trigret res1 = var1 + var2;
                trigret res2 = var3 + var4;
                trigret returned = {surf, is_dot5};
                if(res2.surf < res1.surf){
                    surf = (returned - res2).surf;
                    is_dot5 = (returned - res2).is_dot5;
                }else if(res1.surf > res2.surf){
                    surf = (returned - res1).surf;
                    is_dot5 = (returned - res1).is_dot5;
                }else if(!res1.is_dot5){
                    surf = (returned - res1).surf;
                    is_dot5 = (returned - res1).is_dot5;
                }else{
                    surf = (returned - res2).surf;
                    is_dot5 = (returned - res2).is_dot5;
                }
            }
        }
        if(!isbmid){
            if((dots[a].x == minx && dots[a].y == maxy) || (dots[c].x == minx && dots[c].y == maxy)){
                dots[n] = dot{minx, miny};
                dots[n + 1] = dot{maxx, maxy};
                trigret var1 = triang(c, b, n);
                trigret var2 = triang(a, b, n);
                trigret var3 = triang(c, b, n + 1);
                trigret var4 = triang(a, b, n + 1);
                trigret res1 = var1 + var2;
                trigret res2 = var3 + var4;
                trigret returned = {surf, is_dot5};
                if(res2.surf < res1.surf){
                    surf = (returned - res2).surf;
                    is_dot5 = (returned - res2).is_dot5;
                }else if(res1.surf > res2.surf){
                    surf = (returned - res1).surf;
                    is_dot5 = (returned - res1).is_dot5;
                }else if(!res1.is_dot5){
                    surf = (returned - res1).surf;
                    is_dot5 = (returned - res1).is_dot5;
                }else{
                    surf = (returned - res2).surf;
                    is_dot5 = (returned - res2).is_dot5;
                }
            }else{
                dots[n] = dot{minx, maxy};
                dots[n + 1] = dot{maxx, miny};
                trigret var1 = triang(c, b, n);
                trigret var2 = triang(a, b, n);
                trigret var3 = triang(c, b, n + 1);
                trigret var4 = triang(a, b, n + 1);
                trigret res1 = var1 + var2;
                trigret res2 = var3 + var4;
                trigret returned = {surf, is_dot5};
                if(res2.surf < res1.surf){
                    surf = (returned - res2).surf;
                    is_dot5 = (returned - res2).is_dot5;
                }else if(res1.surf > res2.surf){
                    surf = (returned - res1).surf;
                    is_dot5 = (returned - res1).is_dot5;
                }else if(!res1.is_dot5){
                    surf = (returned - res1).surf;
                    is_dot5 = (returned - res1).is_dot5;
                }else{
                    surf = (returned - res2).surf;
                    is_dot5 = (returned - res2).is_dot5;
                }
            }
        }
        if(!iscmid){
            if((dots[a].x == minx && dots[a].y == maxy) || (dots[b].x == minx && dots[b].y == maxy)){
                dots[n] = dot{minx, miny};
                dots[n + 1] = dot{maxx, maxy};
                trigret var1 = triang(b, c, n);
                trigret var2 = triang(a, c, n);
                trigret var3 = triang(b, c, n + 1);
                trigret var4 = triang(a, c, n + 1);
                trigret res1 = var1 + var2;
                trigret res2 = var3 + var4;
                trigret returned = {surf, is_dot5};
                if(res2.surf < res1.surf){
                    surf = (returned - res2).surf;
                    is_dot5 = (returned - res2).is_dot5;
                }else if(res1.surf > res2.surf){
                    surf = (returned - res1).surf;
                    is_dot5 = (returned - res1).is_dot5;
                }else if(!res1.is_dot5){
                    surf = (returned - res1).surf;
                    is_dot5 = (returned - res1).is_dot5;
                }else{
                    surf = (returned - res2).surf;
                    is_dot5 = (returned - res2).is_dot5;
                }
            }else{
                dots[n] = dot{minx, maxy};
                dots[n + 1] = dot{maxx, miny};
                trigret var1 = triang(b, c, n);
                trigret var2 = triang(a, c, n);
                trigret var3 = triang(b, c, n + 1);
                trigret var4 = triang(a, c, n + 1);
                trigret res1 = var1 + var2;
                trigret res2 = var3 + var4;
                trigret returned = {surf, is_dot5};
                if(res2.surf < res1.surf){
                    surf = (returned - res2).surf;
                    is_dot5 = (returned - res2).is_dot5;
                }else if(res1.surf > res2.surf){
                    surf = (returned - res1).surf;
                    is_dot5 = (returned - res1).is_dot5;
                }else if(!res1.is_dot5){
                    surf = (returned - res1).surf;
                    is_dot5 = (returned - res1).is_dot5;
                }else{
                    surf = (returned - res2).surf;
                    is_dot5 = (returned - res2).is_dot5;
                }
            }
        }
    }
    return trigret{surf, is_dot5};
}

int main()
{
    freopen("triangle.in", "r", stdin);
    freopen("triangle.out", "w", stdout);
    scanf("%d", &n);
    for(int i = 0; i < n; i++){
        scanf("%d %d", &dots[i].x, &dots[i].y);
    }
    for(int a = 0; a < n - 2; a++){
        for(int b = a + 1; b < n - 1; b++){
            for(int c = b + 1; c < n; c++){
                trigret ret = triang(a, b, c);
                if(ret.surf > res){
                    res = ret.surf;
                    is_dot5_res = ret.is_dot5;
                }else if(ret.surf == res){
                    is_dot5_res = is_dot5_res || ret.is_dot5;
                }
            }
        }
    }
    cout << res;
    if(is_dot5_res){
        printf(".5\n");
    }else{
        printf("\n");

    }
    return 0;
}
