/* GCC */
#include <bits/stdc++.h>

using namespace std;

struct pt{
    int x, y;
};

bool operator <(pt a, pt b){return a.x < b.x || (a.y < b.y && a.x == b.x);}

int operator ^(pt a, pt b){return a.x*b.y - a.y*b.x;}

pt operator -(pt a, pt b){return {a.x - b.x, a.y - b.y};}

vector<pt> top, bot;

int area(pt a, pt b, pt c){
    return (a-c)^(b-c);
}

void gen_hull(vector<pt> vec){
    for(int i = 0; i < vec.size(); i++){
        while(top.size() >= 2 && area(top[top.size() - 1], top[top.size() - 2], vec[i]) <= 0)
            top.pop_back();
        top.push_back(vec[i]);
        while(bot.size() >= 2 && area(bot[bot.size() - 1], bot[bot.size() - 2], vec[i]) >= 0)
            bot.pop_back();
        bot.push_back(vec[i]);
    }
}

int main()
{
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    freopen("triangle.in", "r", stdin);
    freopen("triangle.out", "w", stdout);
    int N;
    cin >> N;
    vector<pt> vec(N);
    top.reserve(N);
    bot.reserve(N);
    for(int i = 0; i < N; i++)
        cin >> vec[i].x >> vec[i].y;
    sort(vec.begin(), vec.end());
    gen_hull(vec);
    if(top.size() + bot.size() - 2 <= 2){
        cout << 0;
        return 0;
    }
    int siz = top.size();
    top.resize(top.size() + bot.size() - 2);
    for(int i = bot.size() - 2; i >= 1; i--)
        top[siz - 2 + bot.size() - i] = bot[i];

    int a = 0, b = 1, c = 2;
    for(int i = 3; i < top.size() && abs(area(top[a], top[b], top[c])) < abs(area(top[a], top[b], top[i])); c = i, i++);
    for(int i = 2; abs(area(top[a], top[b], top[c])) < abs(area(top[a], top[i], top[c])); b = i, i++);
    for(int i = top.size() - 1; abs(area(top[a], top[b], top[c])) < abs(area(top[i], top[b], top[c])); a = i, i--);
    int ar = abs(area(top[a], top[b], top[c]));
    if(a&1)
        cout << ar/2 << ".5\n";
    else
        cout << ar/2 << '\n';
    return 0;
}
