#include<iostream>
#include<cstdio>
#include<vector>
#include<queue>

using namespace std;

const int N = 2000;

int n, m, k;
bool bus[N];
vector<int> g[N];

int solve_partial(){
    int v = -1;
    for(int i = 0; i < n; ++i)
        if(g[i].size() == 1){
            v = i;
            break;
        }
    if(v == -1){
        int ans = INT_MAX;
        for(int i = 0; i < n; ++i)
            if(bus[i]){
                v = i;
                break;
            }
        int start = v;
        int last = v;
        int from = v;
        int len = 0;
        do{
            int new_from = v;
            v = (g[v][0] == from ? g[v][1] : g[v][0]);
            from = new_from;
            ++len;
            if(bus[v]){
                ans = min(ans, len);
                last = v;
                len = 0;
            }
        }while(v != start);
        return ans;
    }
    int ans = INT_MAX;
    int last = v;
    int from = v;
    int len = N;
    do{
        int new_from = v;
        v = (g[v][0] == from ? g[v][1] : g[v][0]);
        from = new_from;
        ++len;
        if(bus[v]){
            ans = min(ans, len);
            last = v;
            len = 0;
        }
    }while(g[v].size() != 1);
    return ans;
}

int d[N];
int bfs(int v){
    for(int i = 0; i < n; ++i)
        d[i] = -1;
    queue<int> q;
    d[v] = 0;
    q.push(v);
    while(!q.empty()){
        int v = q.front();
        q.pop();
        for(int i = 0; i < g[v].size(); ++i){
            int u = g[v][i];
            if(d[u] != -1)
                continue;
            d[u] = d[v] + 1;
            if(bus[u])
                return d[u];
            q.push(u);
        }
    }
}

int solve_brute(){
    int ans = INT_MAX;
    for(int i = 0; i < n; ++i)
        if(bus[i])
            ans = min(ans, bfs(i));
    return ans;
}

int main(){
    freopen("hiking.in", "r", stdin);
    freopen("hiking.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);
    cin >> n >> m >> k;
    for(int i = 0; i < m; ++i){
        int v, u;
        cin >> v >> u;
        --v; --u;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    for(int i = 0; i < k; ++i){
        int v;
        cin >> v;
        --v;
        bus[v] = true;
    }
    for(int i = 0; i < n; ++i){
        if(g[i].size() > 2){
            cout << solve_brute() << endl;
            return 0;
        }
    }
    cout << solve_partial() << endl;
}
