#include<algorithm>
#include<iostream>
#include<vector>
#include<cstdio>
#include<cmath>
#define point pair<int, int>
#define x first
#define y second

using namespace std;

const int N = 2000;

int n;
point a[N];

int double_square(point a, point o, point b){
    return (a.x - o.x) * (b.y - o.y) - (b.x - o.x) * (a.y - o.y);
}

struct comp{
    point o;
    comp(point o):o(o){}
    bool operator()(point a, point b){
        int d = double_square(a, o, b);
        return (d > 0 || (d == 0 && a.x > b.x));
    }
};

int sz;
point hull[N];
void build_hull(){
    int j = 0;
    point p = a[0];
    for(int i = 1; i < n; ++i){
        if(a[i] < p){
            p = a[i];
            j = i;
        }
    }
    swap(a[j], a[n-1]);
    sort(a, a+n-1, comp(p));
    hull[sz++] = p;
    for(int i = 0; i < n-1; ++i){
        hull[sz++] = a[i];
        if(sz >= 3){
             int d = double_square(hull[sz-1], hull[sz-2], hull[sz-3]);
             if(d == 0){
                --sz;
                continue;
             }
             while(sz >= 3 && d < 0){
                hull[sz-2] = hull[sz-1];
                --sz;
                d = double_square(hull[sz-1], hull[sz-2], hull[sz-3]);
             }
        }
    }
}

int main(){
    freopen("triangle.in", "r", stdin);
    freopen("triangle.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);
    cin >> n;
    for(int i = 0; i < n; ++i)
        cin >> a[i].x >> a[i].y;
    build_hull();
    int ans = 0;
    for(int i = 0; i < sz; ++i)
        for(int j = i+1; j < sz; ++j)
            for(int k = j+1; k < sz; ++k)
                ans = max(ans, abs(double_square(hull[i], hull[j], hull[k])));
    cout << (ans/2) << (ans%2 ? ".5" : "") << endl;
}
