#include <fstream>
#include <cmath>

double findArea(int lx1, int lx2, int lx3, int ly1, int ly2, int ly3)
{
    double l1 = std::sqrt(lx1 + ly1);
    double l2 = std::sqrt(lx2 + ly2);
    double l3 = std::sqrt(lx3 + ly3);
    double p = (l1 + l2 + l3) / 2;

    double result = std::sqrt((p - l1) * (p - l2) * (p - l3) * p );

    return result;
}

int main()
{
    std::ifstream in("triangle.in");
    std::ofstream out("triangle.out");

    uint_fast32_t number = 0;
    in >> number;

    int * x = new int[number]();
    int * y = new int[number]();

    for(uint_fast32_t i = 0; i < number; i++)
    {
        in >> x[i];
        in >> y[i];
    }

    double area = 0;

    for(uint_fast32_t i = 0; i < number; i++)
    {
        for(uint_fast32_t j = i + 1; j < number; j++)
        {
            for(uint_fast32_t k = j + 1; k < number; k++)
            {
                int lx2 = x[k] - x[j], lx3 = x[k] - x[i], ly2 = y[k] - y[j],  ly3 = y[k] - y[i], lx1 = x[i] - x[j], ly1 = y[i] - y[j];

                area = std::max(area, findArea(lx1 * lx1, lx2 * lx2, lx3 * lx3, ly1 * ly1, ly2 * ly2, ly3 * ly3));
            }
        }
    }

    out << area;

    return 0;
}
