#include <bits/stdc++.h>

using namespace std;

const int nmax = 750;

struct Long {
    short num[nmax] = {0};
    short len=1;
};

int Long_len(Long a) {
    int i;
    for (i = 0; i < nmax-1 && a.num[i] == 0; i++);

    return nmax-i;
}

Long read() {
    Long res;
    string inp;
    cin>>inp;

    res.len = inp.size();

    for (int i = 0; i<res.len; i++) {
        res.num[nmax-res.len+i] = inp[i] - 48;
    }

    return res;
}

void write(Long a) {
    for (int i = nmax-a.len; i < nmax; i++) cout<<a.num[i];
}

int cmp(Long a, Long b) {
    if (a.len > b.len) return 1;
    if (a.len < b.len) return -1;

    for (int i = nmax-a.len; i<nmax; i++) {
        if (a.num[i] > b.num[i]) return 1;
        if (a.num[i] < b.num[i]) return -1;
    }

    return 0;
}


Long move(Long a, int n) {
    Long res;
    res.len = a.len + n;
    for (int i = nmax-res.len; i<nmax-n && i<nmax; i++) {
        res.num[i] = a.num[i+n];
    }

    return res;
}

Long add_abs(Long a, Long b) {
    Long res;
    int p=0, s;
    for (int i = nmax-1; i>=0; i--) {
        s = a.num[i] + b.num[i] + p;
        p = s/10;
        res.num[i] = s%10;
    }

    res.len = Long_len(res);

    return res;
}

Long subtract(Long a, Long b) {
    Long res;
    int p=0, s;
    for (int i = nmax-1; i>=0; i--) {
        s = a.num[i] - b.num[i] - p;
        if (s < 0) {
            p = 1;
            s += 10;
        }
        else p = 0;

        res.num[i] = s;
    }
    res.len = Long_len(res);
    return res;
}


Long mult_by_dig(Long a, int n){
    Long res;
    int p=0, s;

    for (int i = nmax-1; i>=0; i--) {
        s = n*a.num[i] + p;

        p=s/10;
        res.num[i] = s%10;
    }

    res.len = Long_len(res);

    return res;
}

Long mult(Long a, Long b) {
    Long res, tmp[b.len];

    for (int i = 0; i < b.len; i++) {
        tmp[i] = move(mult_by_dig(a, b.num[nmax-1-i]), i);
    }

    for (int i = 0; i<b.len; i++) {
        res = add_abs(res, tmp[i]);
    }

    return res;
}

Long remainder(Long a, Long b) {
    Long one;
    one.num[nmax-1] = 1;

    Long res, right, left;

    if (cmp(a,b) == 0) return res;
    if (cmp(a,b) == -1) return a;


    for (right = one; cmp(mult(right,b), a) != 1; right = mult_by_dig(right, 2)) left = right;


    Long mid;
    while (cmp(add_abs(left,one), right) != 0) {
        mid = move(mult_by_dig(add_abs(left, right), 5), -1);
        if (cmp(mult(mid,b), a) == -1) left = mid;
        else if (cmp(mult(mid,b), a) == 1) right = mid;
        else return res;
    }
    return subtract(a, mult(b, left));
}

void cpy(Long arr1[], Long arr2[], int n) {
    for (int i=0; i<n; i++) arr1[i] = arr2[i];
}

int main()
{
    freopen("cucumbers.in", "r", stdin);
    freopen("cucumbers.out", "w", stdout);
    long long m;
    int n;
    cin>>m>>n;

    Long a[n+1], b[n+1];


    for (int i = 1; i<=n; i++) a[i]=read();
    for (int i = 1; i<=n; i++) b[i]=read();
    Long plants[n+1], prev[n+1];
    prev[0].num[nmax-1] = 1;
    for (int i = 1; i<=m; i++) {

        for (int j = 1; j<=n; j++) {
            plants[j] = prev[j-1];
        }

        for (int j = 1; j<=n; j++) {
            plants[0] = add_abs(mult(plants[j], a[j]), plants[0]);
        }

        cpy(prev, plants, n+1);
    }


    for (int i = 1; i<n; i++) {
        write(remainder(plants[i], b[i])); cout<<" ";
    }
    write(remainder(plants[n], b[n])); cout<<"\n";

    return 0;
}
