/* GCC */
#include <bits/stdc++.h>

using namespace std;

const int Nmax = 2e3+100;

struct point {
    int x, y;
    bool operator<(point a){
        return x < a.x;
    }
    void read() {
        cin >> x >> y;
    }
    bool operator != (point a) {
        return a.x != x || a.y != y;
    }
    point operator-(point a) {
        return {x - a.x, y - a.y};
    }
};

bool is_left_turn(point a, point b) {
    return a.x*b.y > b.x*a.y;
}
int sqr(point a, point b) {
    return abs(a.x*b.y - b.x*a.y);
}
point arr[Nmax];
bool used[Nmax];

int main()
{
	freopen("triangle.in", "r", stdin);
	freopen("triangle.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    for(int i = 0;i < n;++i)
        arr[i].read();

    sort(arr, arr + n);

    vector<point> hull, hA;
    hull.reserve(n);
    int l = 0;
    for(int i = 0;i < n;++i) {
        while(l > 1 && is_left_turn(arr[i] - hull[l-2], hull[l-1] - hull[l-2])) {
            hull.pop_back();
            l--;
        }
        hull.push_back(arr[i]);
        l++;
    }
    l = 0;
    for(int i = n-1;i >= 0;--i) {
        while(l > 1 && is_left_turn(arr[i] - hA[l-2], hA[l-1] - hA[l-2])) {
            hA.pop_back();
            l--;
        }
        hA.push_back(arr[i]);
        l++;
    }
    for(int i = 0;i < l;++i) {
        if(hA[i] != hull.back() && hA[i] != hull[0])
            hull.push_back(hA[i]);
    }

    int pos;
    int ans = 0;
    n = hull.size();
    for(int i = 0;i < n;++i) {
        pos = (i+1) % n;
        for(int j = (i + 2) % n;j != i;j = (j + 1) % n) {
            while((pos+1)%n != j && sqr(hull[i]-hull[pos], hull[j]-hull[pos]) < sqr(hull[i]-hull[(pos+1) % n], hull[j]-hull[(pos+1) % n]))
                pos = (pos + 1) % n;
            ans = max(ans, sqr(hull[i]-hull[pos], hull[j]-hull[pos]));
        }
    }
    cout << ans/2;
    if(ans & 1)
        cout << ".5";
    cout << '\n';

    return 0;
}
