/* GCC */
#include <bits/stdc++.h>
#define int long long
#define fi first
#define se second
#define pb push_back
#define pi 3.14159265358979

using namespace std;

int x[100500];
int y[100500];
int x2[100500];
int y2[100500];
vector<int> conv_hull;
int chull[100500];

int s(int i, int j, int k)
{
    return abs(x[i]*y[j]-x[j]*y[i]+x[j]*y[k]-x[k]*y[j]+x[k]*y[i]-x[i]*y[k]);
}

double angle(int x1, int y1, int x2, int y2)
{
    return acos((x1*x2+y1*y2)*1.0/sqrt(x1*x1+y1*y1)/sqrt(x2*x2+y2*y2));
}

double ang(int x1, int y1, int x2, int y2, int x3, int y3)
{
    if ((x3==x2) and (y3==y2))
        return 0;
    if (x1*y2-x2*y1+x2*y3-x3*y2+x3*y1-x1*y3 >= 0)
        return angle(x1-x2, y1-y2, x3-x2, y3-y2);
    else
        return 2*pi-angle(x1-x2, y1-y2, x3-x2, y3-y2);
}

main()
{
    freopen("triangle.in", "r", stdin);
    freopen("triangle.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin>>n;
    for (int i=0; i<n; i++)
        cin>>x[i]>>y[i];
    int ans=0;
    for (int i=2; i<n; i++)
        ans=max(ans, s(0, 1, i));
    if (ans==0)
    {
        cout<<"0\n";
        return 0;
    }

    int l=0;
    for (int i=1; i<n; i++)
    {
        if (x[i]<x[l])
            l=i;
    }

    conv_hull.pb(l);
    chull[l]=1;

    int m=0;
    double t=ang(x[l], y[l]+1, x[l], y[l], x[m], y[m]);
    for (int i=0; i<n; i++)
    {
        double t0=ang(x[l], y[l]+1, x[l], y[l], x[i], y[i]);
        if (t0>t)
        {
            m=i;
            t=t0;
        }
    }

    conv_hull.pb(m);
    chull[m]=1;

    while (true)
    {
        int cur=conv_hull[conv_hull.size()-1];
        int prev=conv_hull[conv_hull.size()-2];
        m=0;
        t=ang(x[prev], y[prev], x[cur], y[cur], x[m], y[m]);
        for (int i=0; i<n; i++)
        {
            double t0=ang(x[prev], y[prev], x[cur], y[cur], x[i], y[i]);
            if (t0>t)
            {
                m=i;
                t=t0;
            }
        }
        if (chull[m]==1)
            break;
        conv_hull.pb(m);
        chull[m]=1;
    }

    n=conv_hull.size();
    for (int i=0; i<n; i++)
    {
        x2[i]=x[conv_hull[i]];
        y2[i]=y[conv_hull[i]];
    }
    memset(x, 0, sizeof(x));
    memset(y, 0, sizeof(y));
    for (int i=0; i<n; i++)
        x[i]=x[n+i]=x2[i], y[i+n]=y[i]=y2[i];

    ans=0;
    for (int i=0; i<n; i++)
    {
        int j=i;
        int k=i+1;
        while (k<n+i)
        {
            j++;
            ans=max(ans, s(i, j, k));
            while (s(i, j, k+1)>=s(i, j, k))
            {
                k++;
                ans=max(ans, s(i, j, k));
            }
        }
    }
    if (ans%2==0)
        cout<<ans/2<<"\n";
    else
        cout<<ans/2<<".5\n";
    return 0;
}
