/* GCC */
#include <bits/stdc++.h>
using namespace std;


//#define int long long

struct point
{
    int x, y;
};

bool cmp (const point &a, const point &b)
{
    if(a.x==b.x)
        return a.y<b.y;
    return a.x<b.x;
}

int SS(point &a, point &b, point &c)
{
    return a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y);
}
bool cw (point &a, point &b, point &c)
{
    return SS(a, b, c) < 0;
}
bool ccw (point &a, point &b, point &c)
{
    return SS(a, b, c) > 0;
}


int n, x, y;
vector<point> a;
void make_hull()
{
    point p1 = a[0],  p2 = a.back();
    vector<point> up, down;
    up.push_back (p1);
    down.push_back (p1);
    for (size_t i=1; i<a.size(); ++i)
    {
        if (i==a.size()-1 || cw (p1, a[i], p2))
        {
            while (up.size()>=2 && !cw (up[up.size()-2], up[up.size()-1], a[i])){
                up.pop_back();
            }
            up.push_back (a[i]);
        }
        if (i==a.size()-1 || ccw (p1, a[i], p2))
        {
            while (down.size()>=2 && !ccw (down[down.size()-2], down[down.size()-1], a[i])){
                down.pop_back();
            }
            down.push_back (a[i]);
        }
    }
    a.clear();
    for (size_t i=0; i<up.size(); ++i)
        a.push_back (up[i]);
    for (size_t i=down.size()-2; i>0; --i)
        a.push_back (down[i]);
}

int bad()
{
    int ans = 0;
    for(int i = 0; i<a.size(); i++)
        for(int j = i+1; j<a.size(); j++)
            for(int k = j+1; k<a.size(); k++)
                ans = max(ans, abs(SS(a[i], a[j], a[k])));
    return ans;
}
int newans(const int &i, const int &j)
{

    int l = i+1, r = j-1;
    while(r-l>20)
    {
        int left = (r+2*l)/3;
        int right = (2*r+l)/3;
        if(abs(SS(a[i%n], a[left%n], a[j%n]) < abs(SS(a[i%n], a[right%n], a[j%n]))))
        {
            l = left;
        }
        else
        {
            r = right;
        }
    }
    int ans = 0;
    for(int pos = l; pos<=r; pos++)
        ans=max(ans, abs(SS(a[i%n], a[pos%n], a[j%n])));
    return ans;
}

int findans(const int &i)
{
    int l = i+1;
    int r = i-1+n;
    while(r-l>20)
    {
        int left = (r+2*l)/3;
        int right = (2*r+l)/3;
        if(newans(i, left) < newans(i, right))
        {
            l = left;
        }
        else
        {
            r = right;
        }
    }
    int ans = 0;
    for(int pos = l; pos<=r; pos++)
    {
        ans = max(ans, newans(i, pos));
    }
    return ans;
}
int32_t main()
{
    ifstream cin("triangle.in");
    ofstream cout("triangle.out");
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    for(int i = 0; i<n; i++)
    {
        cin >> x >> y;
        a.push_back({x, y});
    }

    sort(a.begin(), a.end(), cmp);
    make_hull();
    int ans = 0;
    n = a.size();
    for(int i = 0; i<n; i++)
    {
        ans = max(ans, findans(i));
    }

    if(ans%2==0)
        cout << ans/2 << '\n';
    else
        cout << fixed << setprecision(1) << (ans+0.0)/2 << '\n';

    return 0;
}
