/* GCC */
#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>
using namespace std;

struct tree
{
    int x, y;
    tree(int _x, int _y) : x(_x), y(_y){}
    tree(){}
    tree& operator=(tree& r)
    {
        x = r.x;
        y = r.y;
        return *this;
    }
};

struct triangle
{
    tree trees[3];
    double square;
    triangle(tree _trees[])
    {
        for(int i = 0; i < 3; i++)
        {
            trees[i] = _trees[i];
        }
        double l[3];
        l[0] = sqrt(pow((trees[2].x - trees[1].x), 2) + pow((trees[2].y - trees[1].y), 2));
        l[1] = sqrt(pow((trees[1].x - trees[0].x), 2) + pow((trees[1].y - trees[0].y), 2));
        l[2] = sqrt(pow((trees[2].x - trees[0].x), 2) + pow((trees[2].y - trees[0].y), 2));
        double p = (l[0] + l[1] + l[2])/2.0f;
        square = sqrt(p * (p-l[0]) * (p-l[1]) * (p - l[2]));
    }
};

vector<tree> trees;
vector<triangle> triangles;

void searchForTriangle(int n)
{
    for(register int i = 0; i < trees.size(); ++i)
    {
        for(register int j = 0; j < trees.size(); ++j)
        {
            if(i == j || i == n || j == n) continue;
            tree ltrees[3];
            ltrees[0] = trees[n];
            ltrees[1] = trees[i];
            ltrees[2] = trees[j];
            triangles.push_back(triangle(ltrees));
        }
    }
}

int main()
{
    ifstream fin("triangle.in");
    ofstream fout("triangle.out");
    int n = 0;
    fin >> n;
    for(register int i = 0; i < n; ++i)
    {
        int lx, ly;
        fin >> lx >> ly;
        trees.push_back(tree(lx, ly));
    }
    for(register int i = 0; i < n; ++i)
    {
        searchForTriangle(i);
    }
    int z = 0;
    for(register int i = 0; i < triangles.size(); i++)
    {
        if(triangles[i].square >= triangles[z].square) z = i;
    }
    fout << triangles[z].square << endl;
    return 0;
}
