/* GCC */
#include <iostream>
#include <vector>
#include <fstream>
#include <limits>

using namespace std;

bool Check(bool Visited[2000], int NotAmount)
{
    for(int i = 0; i < NotAmount; i++) if(Visited[i] == false) return true;
    return false;
}

bool IsBusStop(int BusStops[2000], int j, int BusStopAmount)
{
    for(int i = 0; i < BusStopAmount; i++) if(BusStops[i] == j) return true;
    return false;
}

int CountMinimal(int BusStops[2000], int i, int Distance[2000], int NotAmount, int BusStopAmount)
{
    int MinDist = INT_MAX;
    for(int j = 0; j < NotAmount; j++) if(i != j && IsBusStop(BusStops, j, BusStopAmount) && Distance[j] < MinDist && Distance[j] > 0) MinDist = Distance[j];
    return MinDist;
}

void PlaceDist(int Roads[2000][2], int BusStops[2000], int i, bool Visited[2000], int Distance[2000], int NotAmount, int BusStopAmount, int RoadAmount, int Step)
{
    if(Visited[i] == false && Check(Visited, NotAmount)) {
        Visited[i] = true;
        Distance[i] = Step;
        for(int j = 0; j < RoadAmount; j++) {
            if(Roads[j][0] == i && Visited[Roads[j][1]] == false) PlaceDist(Roads, BusStops, Roads[j][1], Visited, Distance, NotAmount, BusStopAmount, RoadAmount, Step + 1);
            if(Roads[j][1] == i && Visited[Roads[j][0]] == false) PlaceDist(Roads, BusStops, Roads[j][0], Visited, Distance, NotAmount, BusStopAmount, RoadAmount, Step + 1);
        }
    }
}

int main()
{
    ifstream Input("hiking.in");
    ofstream Output("hiking.out");
    int NotAmount, RoadAmount, BusStopAmount;
    Input >> NotAmount >> RoadAmount >> BusStopAmount;
    int Roads[2000][2], BusStops[2000];
    for(int i = 0; i < RoadAmount; i++) {
        Input >> Roads[i][0] >> Roads[i][1];
        Roads[i][0]--;
        Roads[i][1]--;
        if(Roads[i][0] > Roads[i][1]) swap(Roads[i][0], Roads[i][1]);
    }
    for(int i = 0; i < BusStopAmount; i++) {
        Input >> BusStops[i];
        BusStops[i]--;
    }

    bool flag = true;
    int MinDist = INT_MAX;
    for(int i = 0; i < BusStopAmount && flag; i++) {
        bool Visited[2000];
        int Distance[2000];
        for(int j = 0; j < NotAmount; j++) {
            Visited[j] = false;
            Distance[j] = 0;
        }
        PlaceDist(Roads, BusStops, BusStops[i], Visited, Distance, NotAmount, BusStopAmount, RoadAmount, 0);

        int CurrDist = CountMinimal(BusStops, i, Distance, NotAmount, BusStopAmount);
        if(CurrDist < MinDist) MinDist = CurrDist;
        if(MinDist == 1) flag = false;
    }
    Output << MinDist << endl;
    Input.close();
    Output.close();
    return 0;
}
